config/routes.rb
Rails.application.routes.draw do

  # use_doorkeeper
  scope 'api' do
    use_doorkeeper do
      skip_controllers :authorizations, :applications, :authorized_applications
    end
  end

  mount Rswag::Ui::Engine => '/api-docs'
  mount Rswag::Api::Engine => '/api-docs'

  mount ProwhyApi::Api => '/api'

  scope '(:locale)', locale: /#{I18n.available_locales.join("|")}/ do
    # mount ProwhyApi::Api => '/api'

    # your routes here...
    namespace :labels do
      resources :cause_types
      get 'cause_types_list', to: 'cause_types#cause_types_list'
      post 'cause_types_list_set', to: 'cause_types#cause_types_list_set'
      resources :criteria
      resources :configs
      get 'config_add_criteria', to: 'configs#add_criteria'
      patch 'config_add_criteria_valid', to: 'configs#add_criteria_valid'
      get 'config_formula_test', to: 'configs#formula_test'
      resources :values
      resources :qqoqcp_lines
      resources :qqoqcp_configs
      get 'qqoqcp_config_add_line', to: 'qqoqcp_configs#add_line'
      patch 'qqoqcp_config_add_line_valid', to: 'qqoqcp_configs#add_line_valid'
      resources :check_list_elems
    end

    # scope module: 'tools' do
    namespace :tools do
      resources :qqoqcps
      resources :causes, only: [:new, :create, :edit, :update, :destroy]
      get 'cause_edit_status', to: 'causes#edit_status'
      resources :tasks
      resources :decision_mats
      # Cause Tree
      resources :cause_trees, only: [:index]
      get 'cause_trees_js_tree_data', to: 'cause_trees#cause_trees_js_tree_data'
      # Cause Tree => 5Why
      get 'cause_trees_index_5why', to: 'cause_trees#index_5why'
      # Ishikawa
      resources :ishikawas, only: [:index]
      get 'ishikawa_js_tree_data', to: 'ishikawas#ishikawa_js_tree_data'
      post 'ishikawa_drag_cause', to: 'ishikawas#ishikawa_drag_cause'
      get 'ishikawa_reset_branchs', to: 'ishikawas#ishikawa_reset_branchs'
      get 'ishikawa_zoom', to: 'ishikawas#ishikawa_zoom'
      post 'ishikawa_update_option', to: 'ishikawas#ishikawa_update_option'
      post 'save_canvas_to_png', to: 'ishikawas#save_canvas_to_png'
      post 'save_image', to: 'ishikawas#save_image'
      # Tasks
      get 'tasks_index_js', to: 'tasks#index_js'
      get 'tasks_export_pdf', to: 'tasks#export_pdf'
      get 'task_get_cause', to: 'tasks#task_get_cause'
      patch 'task_update_advance', to: 'tasks#update_advance'
      get 'tasks_send_emails', to: 'tasks#send_emails'
      post 'tasks_index_posts', to: 'tasks#index'
      get 'tasks_index_posts', to: 'tasks#index'

      get 'tasks_check_list', to: 'tasks#check_list'
      post 'tasks_check_list_valid', to: 'tasks#check_list_valid'

      get 'tasks_reschedule', to: 'tasks#reschedule'

      # Decision Mats
      # get 'decision_mat_open', to: 'decision_mats#open'
      patch 'decision_mat_save_values', to: 'decision_mats#save_values'
      delete 'decision_mat_delete_entry', to: 'decision_mats#delete_entry'
      get 'decision_mat_add_entry', to: 'decision_mats#add_entry'
      patch 'decision_mat_valid_entries', to: 'decision_mats#valid_entries'
      get 'decision_mat_add_criteria', to: 'decision_mats#add_criteria'
      patch 'decision_mat_valid_criteria', to: 'decision_mats#valid_criteria'
      # Teams
      resources :teams
      # Documents
      resources :documents
      # RcaRport
      resources :rca_reports, only: [:index]
      get 'rca_report_export', to: 'rca_reports#rca_report_export'
      get 'rca_report_comm', to: 'rca_reports#rca_report_comm'
      get 'rca_report_add_person', to: 'rca_reports#rca_report_add_person'
      get 'rca_report_add_person_do', to: 'rca_reports#rca_report_add_person_do'
      # Criticity
      resources :criticities
      patch 'criticity_calculate', to: 'criticities#calculate'
      # Images
      resources :images
      # Indicators
      resources :indicators
      post 'indicator_save_image', to: 'indicators#save_image'
      resources :indicator_measures
      patch 'indicator_measure_up', to: 'indicator_measures#indicator_measure_up'
      patch 'indicator_measure_down', to: 'indicator_measures#indicator_measure_down'
      # Check Efficacity
      resources :check_efficacity, only: [:index]
      get 'check_efficacity_edit_efficacity', to: 'check_efficacity#edit_efficacity'
      # Efficacity
      resources :efficacities
      # Generic
      resources :generics
      get 'generics_download_last_doc', to: 'generics#download_last_doc'
      # RcaList
      resources :rca_lists
    end

    namespace :meth do
      resources :tools
      resources :activities
      resources :list_contents # , only: [:index]
      resources :custom_field_descs
      resources :custom_field_types
      resources :steps
      resources :methodologies
      resources :step_tools
      resources :tool_custom_fields
      get 'step_tool_show', to: 'step_tools#step_tool_show'
      get 'step_tool_import', to: 'step_tools#step_tool_import'
      post 'step_tool_import_do', to: 'step_tools#step_tool_import_do'
      # Fonctions step à mettre dans des services
      get 'step_import', to: 'steps#step_import'
      post 'step_import_do', to: 'steps#step_import_do'
      get 'step_copy', to: 'steps#step_copy'
      post 'step_copy_do', to: 'steps#step_copy_do'
      delete 'step_del_tool', to: 'steps#step_del_tool'
      post 'step_add_tool', to: 'steps#step_add_tool'
      patch 'step_tool_up', to: 'steps#step_tool_up'
      patch 'step_tool_down', to: 'steps#step_tool_down'
      patch 'step_up', to: 'steps#step_up'
      patch 'step_down', to: 'steps#step_down'

      get 'tool_active', to: 'tool#tool_active'

      patch 'list_content_up', to: 'list_contents#list_content_up'
      patch 'list_content_down', to: 'list_contents#list_content_down'
      get 'list_content_new_from_csv', to: 'list_contents#new_from_csv'
      post 'list_content_create_from_csv', to: 'list_contents#create_from_csv'
      get 'list_content_export_csv', to: 'list_contents#export_csv'
      get 'list_content_export_save_csv', to: 'list_contents#export_save_csv'

      delete 'custom_field_desc_delete_all_list', to: 'custom_field_descs#delete_all_list'
      get 'custom_field_desc_dependant_fields_refresh', to: 'custom_field_descs#dependant_fields_refresh'
      get 'custom_field_desc_update_list_dependencies', to: 'custom_field_descs#update_list_dependencies'

      get 'show_tool_custom_field', to: 'tool_custom_fields#show_tool'
      patch 'tool_custom_field_up', to: 'tool_custom_fields#tool_custom_field_up'
      patch 'tool_custom_field_down', to: 'tool_custom_fields#tool_custom_field_down'

      get 'methodology_edit_meth', to: 'methodologies#edit_meth'
      post 'methodology_copy', to: 'methodologies#copy'

      # Tree Cntent for Custom fields
      resources :tree_contents
      get 'tree_contents_js_tree_data', to: 'tree_contents#js_tree_data'
    end

    namespace :admin do
      resources :admin_configs, only: [:index, :edit, :update]
      delete 'admin_config_delete_customer', to: 'admin_configs#delete_customer'
      resources :ldap_configs
      get 'ldap_config_test', to: 'ldap_configs#ldap_config_test'
      resources :perimeters
      get 'perimeters_assign_users', to: 'perimeters#assign_users'
      get 'perimeters_js_tree_data', to: 'perimeters#js_tree_data'
      patch 'perimeters_assign_users_valid', to: 'perimeters#assign_users_valid'
      resources :helper_texts
    end

    resources :custom_fields
    devise_for :users, controllers: { registrations: 'users/registrations',
                                      sessions: 'users/sessions' }
    devise_scope :user do
      get 'edit_user_preferences_registration', to: 'users/registrations#edit_preferences'
      patch 'update_user_preferences_registration', to: 'users/registrations#update_preferences'
    end
    resources :users_admin, controller: 'users', only: [:index, :new, :create, :edit, :update, :destroy]
    get 'users_admin_send_test_mail', to: 'users#send_test_mail'
    get 'users_admin_ldap_search', to: 'users#ldap_search'
    post 'users_admin_ldap_search_valid', to: 'users#ldap_search_valid'
    patch 'users_admin_update_pa_options', to: 'users#update_pa_options'
    resources :rcas
    patch 'rca_advancement_set', to: 'rcas#advancement_set'
    patch 'rca_reinit_all_advancements', to: 'rcas#reinit_all_advancements'
    get 'rca_closure', to: 'rcas#rca_closure'
    # patch 'rcas_search', to: 'rcas#rcas_search'
    patch 'rcas', to: 'rcas#index'
    patch 'rcas_reinit_filters_index', to: 'rcas#reinit_filters_index'
    get 'rcas_reinit_filters', to: 'rcas#reinit_filters'
    patch 'rcas_items_pp', to: 'rcas#rcas_items_pp'
    # get 'rcas_action_plan', to: 'rcas#rcas_action_plan'
    get 'rcas_assign_perimeters', to: 'rcas#assign_perimeters'
    patch 'rcas_assign_perimeters_valid', to: 'rcas#assign_perimeters_valid'
    get 'rca_recovery', to: 'rcas#recovery'
    patch 'rca_recovery_do', to: 'rcas#recovery_do'
    get 'rca_export_ods', to: 'rcas#export_ods'
    get 'rca_add_parent', to: 'rcas#rca_add_parent'
    patch 'rca_add_parent_valid', to: 'rcas#rca_add_parent_valid'
    delete 'rca_delete_parent', to: 'rcas#rca_delete_parent'

    resources :posts
    resources :tags, only: [:index, :show, :update]
    resources :admin, only: [:index]
    get 'admin_show_ahoy', to: 'admin#show_ahoy'
    resources :people
    get 'person_choose', to: 'people#person_choose'
    get 'person_choose_valid', to: 'people#person_choose_valid'
    resources :profils
    patch 'profil_raz_authorizations', to: 'profils#raz_authorizations'
    resources :profil_authorizes, only: [:index, :create, :update]
    resources :roles, only: [:index, :create]

    get 'tagged/:tag', to: 'posts#index', as: :tagged

    get 'tags_list', to: 'tags#tags_list'
    get 'tags_js_tree_data', to: 'tags#tags_js_tree_data'

    # get 'create_route_js', to: 'rcas#create_route_js'

    # get 'causes_js_tree_data', to: 'causes#causes_js_tree_data'

app/models/meth/tool.rb
require_dependency 'meth'

module Meth
  class Tool < ApplicationRecord
    include MethConcern

    translates :name, fallback: :any

    belongs_to :activity # , class_name: 'Meth::Activity'
    has_many :step_tools, dependent: :destroy
    has_many :steps, through: :step_tools

    validates :name, presence: true
    validates :tool_name, presence: true

    # serialize :tool_options
    def tool_options
      @tool_options ||= super&.deep_symbolize_keys!
    end

    after_initialize do
      if new_record?
        # Initialisation des tool_options
        self.tool_options ||= {}
      end
    end

    def self.find_or_create_custom_field
      return Tool.where(tool_name: 'CustomField').first || Tool.create!(name_fr: 'Champs personnalisés',
                                                                        name_en: 'Custom Fields',
                                                                        tool_name: 'CustomField',
                                                                        activity: Activity.find_or_create_infos)
    end

    def self.find_or_create_tool(options)
      return Tool.where(options).first || Tool.create!(name_fr: options[:tool_name].capitalize,
                                                       name_en: options[:tool_name].capitalize,
                                                       tool_name: options[:tool_name],
                                                       activity: Activity.find_or_create_infos)
    end
  end
end

app/models/tools/cause.rb
require_dependency 'tools'

module Tools
  class Cause < ApplicationRecord
    # has_ancestry
    include ToolModelConcern
    include AncestryConcern

    include ToolMatrixable

    enum status: { in_progress: 0, validated: 1, invalidated: 2 }, _prefix: true
    # enum level: { '0': 0, '-': -1, '--': -2, '+': 1, '++': 2 }, _prefix: true
    enum level: { '-': -1, '+': 1, '++': 2 }, _prefix: true
    # belongs_to :rca
    validates :name, presence: true
    validate :parent_from_same_rca

    before_save :name_valid_html

    # Liens vers les tools (tree & ishi) existent uniquement pour les Head Causes
    has_many :cause_links, dependent: :destroy # , foreign_key: :cause_id, class_name: 'Tools::CauseLink'
    # has_many :cause_tools, through: :cause_links

    # vérifier si on garde dependent destroy ou si on crée une fonction qui déconnecte l'action de la cause
    has_many :tools_tasks, foreign_key: :tools_cause_id, class_name: 'Tools::Task', dependent: :destroy

    # Lien vers les branches d'ishikawas
    has_many :tools_cause_classes, class_name: 'Tools::CauseClass', foreign_key: :tools_cause_id,
                                   dependent: :destroy, inverse_of: :tools_cause
    # inverse_of: :tools_cause => pour que le create fonctionne avec les nested attributes, sinon tool_cause_id est nul
    has_many :tools_ishikawas, class_name: 'Tools::Ishikawa', through: :tools_cause_classes
    has_many :labels_cause_types, class_name: 'Labels::CauseType', through: :tools_cause_classes

    accepts_nested_attributes_for :tools_cause_classes

    # options = { rca: rca, tool_reference: tool_reference }
    def self.create_default!(options, _step_tool)
      create!(options.except!(:tool_num).merge!(name: options[:rca].long_title, status: :validated))
    end

    def self.search_default(rca, tool_name, step_tool)
      return nil unless rca.send(tool_name) && step_tool

      return rca.send(tool_name).where(tool_reference: step_tool.tool_reference, ancestry: nil).first
    end

    # def tool_num
    #   1
    # end

    def name_with_level
      level.nil? ? name : "(#{level}) #{name}"
    end

    # Ishikawa => peut-être à mettre dans des services ?

    # return cause type id if cause is classed for this ishikawa
    def ishi_cause_type_id(ishikawa)
      tcc = tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
      return tcc&.labels_cause_type ? tcc.labels_cause_type_id : 0
    end

    def ishi_cause_type(ishikawa)
      tcc = tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
      return tcc ? tcc.labels_cause_type : nil
    end

    def ishi_cause_class(ishikawa)
      tools_cause_classes&.where(tools_ishikawa: ishikawa)&.first
    end

    def add_ishi_cause_type(ishikawa, ctype_id)
      if ctype_id == 0
        del_ishi_cause_type(ishikawa)
      else
        tcc = ishi_cause_class(ishikawa)

        if tcc
          tcc.labels_cause_type_id = ctype_id
          # del_ishi_cause_type(ishikawa) unless tcc.save
          begin
            tcc.save
          rescue StandardError
            del_ishi_cause_type(ishikawa)
          end
        else
          tcc = Tools::CauseClass.create!(tools_cause: self, tools_ishikawa: ishikawa, labels_cause_type_id: ctype_id)
        end
      end
      return tcc
    end

    def del_ishi_cause_type(ishikawa)
      tcc = ishi_cause_class(ishikawa)

      # tcc&.destroy
      tcc.labels_cause_type = nil
      tcc.save!
    end

    def update_cause_status_from_tasks
      tasks_v = tools_tasks.where(task_detail_type: 'Tools::TaskValidation')
      return if tasks_v.empty?

      new_status = 'invalidated'
      tools_tasks.where(task_detail_type: 'Tools::TaskValidation').each do |task_v|
        next unless task_v.task_detail

        case task_v.task_detail.status
        when 'in_progress'
          new_status = new_status == 'validated' ? 'validated' : 'in_progress'
        when 'validated'
          new_status = 'validated'
        when 'invalidated'
          new_status = new_status == 'invalidated' ? 'invalidated' : new_status
          # else
          #   puts 'PROBLEME DE TYPE DE STATUS ===============================>'.yellow
        end
      end
      update(status: new_status) unless new_status == status
    end

    def init_ishikawas_list
      ishikawas, ishikawa_names = rca.init_ishikawas_list_ref(tool_reference)

      return ishikawas, ishikawa_names
    end

    # A PRIORI INULTILES => A VOIR...

    # def init_ishikawas_cause_classes
    #   ishikawas, _ishikawa_names = rca.init_ishikawas_list
    #   ishikawas&.each do |ishikawa|
    #     init_ishikawa_cause_class(ishikawa)
    #   end
    # end

    # def init_ishikawa_cause_class(ishikawa)
    #   add_ishi_cause_type(ishikawa, nil)
    # end

    private

    def name_valid_html
      # puts "NAME".yellow
      # puts name.red
      name.gsub!(/([<>])/, ' \1 ')
      name.gsub!(/( +)/, ' ')
      # binding.pry
      # puts name.blue
    end

    def parent_from_same_rca
      return unless parent && rca && parent.rca != rca

      errors.add(:parent_id, 'Parent cause is not assigned to same rca as current cause.')
    end
  end
end

app/models/tools/cause_class.rb
require_dependency 'tools'

module Tools
  class CauseClass < ApplicationRecord
    belongs_to :tools_cause, class_name: 'Tools::Cause' # , inverse_of: :tools_cause_classes
    belongs_to :tools_ishikawa, class_name: 'Tools::Ishikawa'
    belongs_to :labels_cause_type, class_name: 'Labels::CauseType', optional: true

    # accepts_nested_attributes_for :labels_cause
  end
end

app/models/tools/cause_link.rb
require_dependency 'tools'

module Tools
  class CauseLink < ApplicationRecord
    belongs_to :cause # , class_name: 'Tools::Cause'
    belongs_to :cause_tool, polymorphic: true
  end
end

app/models/tools/crit_dec_mat.rb
require_dependency 'tools'

module Tools
  class CritDecMat < ApplicationRecord
    belongs_to :labels_criterium, class_name: 'Labels::Criterium'
    belongs_to :decision_mat # , class_name: 'Tools::DecisionMat'

    has_many :dec_mat_vals, dependent: :destroy
  end
end

app/models/tools/criticity_value.rb
require_dependency 'tools'

module Tools
  class CriticityValue < ApplicationRecord
    belongs_to :criticity
    belongs_to :labels_criterium, class_name: 'Labels::Criterium'
    belongs_to :labels_value, class_name: 'Labels::Value', optional: true
  end
end

app/views/tools/tasks/_form_validation.html.erb
<!-- VALIDATION -->
<hr><div class='bandeau-tasks'>Validation</div>

<%= f.simple_fields_for(:task_detail) do |task_detail_form| %>
  <%= task_detail_form.input :status, collection: Tools::TaskValidation.statuses.symbolize_keys.keys %>
<% end %>

app/views/tools/tasks/_index.html.erb
<div class="admin-col-title admin-col-title-grey admin-col-title-bold">
  Actions

  <% if show_buttons %>
    <!-- Columns -->
    <div class='column-block'>
      <!-- <a id='tasks-column-sel' href='#' class='btn btn-outline-warning'>COL RESULT</a> -->
      <a id='header-collapse-columns' class="btn btn-outline-warning collapsed" type="button" data-toggle="collapse" data-target="#collapse-columns" aria-expanded="false" aria-controls="collapse-columns">
        <%= t('tasks.show_columns') %>
      </a>
      <div id='collapse-columns' class="collapse">
        <% #index = 2
           #index += 1 if @set_check_box_email
           #index += 1 unless (plan_options[:rcas] || plan_options[:type_plan] == 'rca')
        %>
        <% Tools::Task.all_tasks_columns.each do |col_block, columns| %>
          <% if col_block.to_s == 'object' || plan_options[col_block.intern] %>
            <% columns.each do |col| %>
              <div>
                <%= check_box_tag "columns[#{col}]", 'true', @task_columns[col_block.to_s]&.include?(col.to_s), class: 'column-check', 'column-title': col, 'column-block': col_block.to_s %>
                <% if col_block.to_s == 'object' %>
                  <%= Tools::Task.human_attribute_name col %>
                <% elsif col_block.to_s == 'matrix' %>
                  <%= Tools::MatrixStat.human_attribute_name col %>
                <% elsif col_block.to_s == 'validation' %>
                  <%= Tools::TaskValidation.human_attribute_name col %>
                <% elsif col_block.to_s == 'efficacity' %>
                  <%= Tools::Efficacity.human_attribute_name col %>
                <% else %>
                  <%= Tools::Task.human_attribute_name col %>
                <% end %>
              </div>
              <% #index += 1 %>
            <% end %>
          <% end %>
        <% end %>

        <%= link_to fa_icon('redo-alt', class: 'icon-grey icon-btn icon-margin') + t('tasks.columns_reload'), meth_step_tool_show_path(id: @step_tool, rca: @rca), class: 'btn btn-outline-dark' %>
      </div>
    </div>
    <!-- End Columns -->
    <!-- Check List Actions -->
    <% if plan_options['check_list'] == true %>
      <%= link_to fa_icon('list', class: 'fas icon-grey icon-btn icon-margin') + Labels::CheckListElem.model_name.human(count: 2), tools_tasks_check_list_path(id: @step_tool, rca: @rca), remote: true, class: 'btn btn-outline-dark' %>
    <% end %>
  <% end %>

  <div style="float: right">
    <% if @rca %> <!-- && show_buttons -->
      <% @step_tool.tool_options[:task_options] ||= {} %>
      <%= link_to fa_icon_add('icon-orange icon-margin') + t('.title', task: Tools::Task.model_name.human),
                  new_tools_task_path(tools_task: @step_tool.tool_options[:task_options].merge({
                      rca_id: @rca.id,
                      tool_reference: @step_tool.tool_reference,
                      tool_num: @step_tool.tool_num,
                      responsible_rca_id: @rca&.rca_first_responsible&.id || current_user.person.id,
                      responsible_action_id: current_user.person.id}),
                    efficacity: plan_options[:efficacity],
                    matrix: plan_options[:matrix]),
                  class: 'btn btn-outline-warning',
                  remote: true
      %>
    <% end %>

    <%= link_to fa_icon('arrow-circle-down', class: 'icon-grey icon-btn icon-margin') + 'Export PDF',
                tools_tasks_export_pdf_url(rca: @rca, format: :pdf),
                class: 'btn btn-outline-dark' %>


    <%= send_mail_submit_tag if @set_check_box_email %>
  </div>
</div>

<div class="admin-col-content">
  <div id="tasks-plan" style="overflow-x: scroll;">
    <%= render partial: 'tools/tasks/index_task_plan', locals: {plan_options: plan_options, task_options: task_options, show_buttons: show_buttons} %>
  </div>
</div>

<script>
  $(function() {

  });
</script>

app/views/tools/tasks/_task_line.html.erb
<tr class="<%= tools_task.ancestry ? 'task-line tablesorter-childRow' : 'task-line-root' %>">
    <% if @set_check_box_email %>
      <td>
        <%= check_box_tag "task_email[#{tools_task.id}]", 'send', false %>
      </td>
    <% end %>

    <% unless plan_options[:rcas] || plan_options[:type_plan] == 'rca' %>
      <td>
        <%= link_to ("#{tools_task.rca.reference}-#{tools_task.rca.title}".truncate(22)+'  '+fa_icon_edit).html_safe, edit_rca_path(tools_task.rca), title: tools_task.rca.title %>
      </td>
    <% end %>

    <% if show_column('object', 'ref') %>
      <td>
          <%= tools_task.reference %>
      </td>
    <% end %>

    <td class='task-title'>
        <%= tools_task.name_level.html_safe %>
    </td>

    <% if show_column('object', 'advancement') %>
      <td>
        <span style="visibility: hidden;font-size: 1px;"><%= tools_task.advancement %></span>
        <%= tools_task.dec_level.html_safe %>
        <%=raw task_advance_helper(tools_task, animation: false, size: 20) %>
      </td>
    <% end %>
    <% if show_column('object', 'responsible_action') %>
      <td><%= tools_task.responsible_action&.name %></td>
    <% end %>
    <% if show_column('object', 'responsible_rca') %>
      <td><%= tools_task.responsible_rca&.name %></td>
    <% end %>
    <% if show_column('object', 'result') %>
      <td><%= tools_task.result %></td>
    <% end %>
    <% if show_column('object', 'priority') %>
      <td>
        <%= t(tools_task.priority, scope: [:simple_form, :options, :tools_task, :priority]) %>
      </td>
    <% end %>
    <% if show_column('object', 'date_due') %>
      <td >
        <span style="visibility: hidden;font-size: 1px;"><%= tools_task.task_late? ? 'L' : 'I' %></span>
        <%= task_date_due_helper(tools_task) %>
      </td>
    <% end %>
    <% if show_column('object', 'date_completion') %>
      <td><%= tools_task.date_completion %></td>
    <% end %>

    <!-- Matrix Status -->
    <% if plan_options[:matrix] && show_column('matrix', 'matrix_status')%>
      <td><%= task_status_matrix(tools_task) %></td>
    <% end %>

    <!-- TaskValidation -->
    <% if plan_options[:validation] && show_column('validation', 'status') %>
      <td><%= task_validation_status(tools_task) %></td>
    <% end %>

    <!-- Efficacity -->
    <% if plan_options[:efficacity] %>
      <% if show_column('efficacity', 'check_status') %><td><%= efficacity_status(tools_task) %></td><% end %>
      <% if show_column('efficacity', 'percentage') %><td><%= efficacity_percentage_show(tools_task) %></td><% end %>
      <% if show_column('efficacity', 'date_due_check') %><td><%= efficacity_date_due(tools_task) %></td><% end %>
      <% if show_column('efficacity', 'date_done_check') %><td><%= efficacity_date_done(tools_task) %></td><% end %>
    <% end %>

    <% if show_buttons %>
      <td class='table-cell-links'>
          <% if plan_options[:sub_type_plan] == 'normal' || (!rca || tools_task.rca_id == rca.id) %>
            <%= link_to fa_icon_edit, edit_tools_task_path(tools_task, efficacity: plan_options[:efficacity],
                                                                       matrix: plan_options[:matrix]), remote: true %>
            <%= link_to fa_icon_delete, tools_task, method: :delete, data: { confirm: t('confirm.sure') } %>
          <% end %>
          <% if rca && tools_task.rca_id == rca.id %>
            <%= link_to fa_icon_add,
                        # new_tools_task_path(tools_task: @step_tool.tool_options.merge({
                        new_tools_task_path( tools_task: { task_detail_type: tools_task.task_detail_type,
                              rca_id: rca.id,
                              tool_reference: tools_task.tool_reference,
                              tool_num: tools_task.tool_num,
                              tools_cause_id: tools_task.tools_cause_id,
                              responsible_rca_id: tools_task.responsible_rca_id,
                              responsible_action_id: tools_task.responsible_action_id,
                              parent_id: tools_task.id },
                          efficacity: plan_options[:efficacity],
                          matrix: plan_options[:matrix]),
                        title: 'Add sub-action',
                        remote: true
            %>
          <% end %>
      </td>
    <% end %>
</tr>

<%# tools_task.children.order(@step_tool.tool_options[:blocks]).each do |child_task| %>
    <%#= render partial: 'tools/tasks/task_line', locals: {rca: rca, tools_task: child_task, plan_options: plan_options, show_buttons: show_buttons} %>
<%# end %>

app/views/tools/tasks/edit.html.erb
<h1>Editing Tools Task</h1>

<%= render 'form', tools_task: @tools_task %>

<%= link_to t('back'), tools_tasks_path(rca: @tools_task.rca_id) %>

app/views/tools/tasks/new.html.erb
<h1>New Tools Task</h1>

<%= render 'form', tools_task: @tools_task %>

<%= link_to t('back'), tools_tasks_path(rca: @tools_task.rca_id) %>